Timer = require "timer"

function love.load()

	--[[
	Obstacle Vars AKA blocks
	--]]
	blk = {}
	--blk.img = love.graphics.newImage("tile.png")

	--[[
	Map, borrowed from the LOVE wiki ;)
	--]]
	 tile = {}
    for i=0,1 do
        tile[i] = love.graphics.newImage( "img/tile"..i..".png" )
    end
    
    map={
    { 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0}, 
    { 0, 0, 0, 0, 0, 1, 1, 0, 1, 0, 1, 0, 1, 1, 1, 0, 0, 1, 0, 0, 0},
    { 0, 1, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0}
    }
        
    map_w = #map[1]
    map_h = #map
    map_x = 0
    map_y = 0
    map_display_buffer = 2
    map_display_w = 20
    map_display_h = 15
    tile_w = 8
    tile_h = 8
    cx = 0
    cy = 0
    --[[
	Player Vars
	--]]
	ply = {}
	ply.health = 3
	ply.x = 0
	ply.y = 0
	ply.img = love.graphics.newImage("img/bit.png")
	ply.score = 0
	ply.l = 0
	ply.u = 0
	ply.d = 0
	ply.inv = true
end
	
function draw_map()
    offset_x = map_x % tile_w
    offset_y = map_y % tile_h
    firstTile_x = math.floor(map_x / tile_w)
    firstTile_y = math.floor(map_y / tile_h)
    
    for y=1, (map_display_h + map_display_buffer) do
        for x=1, (map_display_w + map_display_buffer) do
            if y+firstTile_y >= 1 and y+firstTile_y <= map_h
                and x+firstTile_x >= 1 and x+firstTile_x <= map_w
            then
                love.graphics.draw(
                    tile[map[y+firstTile_y][x+firstTile_x]], 
                    (x*tile_w) - offset_x - tile_w, 
                    (y*tile_h) - offset_y - tile_h)
            end
        end
    end
end

Timer.add(5, function() ply.inv = false end)

Timer.addPeriodic(1, function()
	ply.score = ply.score + 1
	move()
end)

function love.keypressed(key)
	if key == "up" and ply.y > 0 then
		ply.y = ply.y - 8
	end
	if key == "down" and ply.y < 16 then
		ply.y = ply.y + 8
	end
	if key == "right" then
		ply.x = ply.x + 8
	end
	if key == "left" then
		ply.x = ply.x - 8
	end
end

function love.update(dt)
	Timer.update(dt)
		cx = math.floor(ply.x / tile_w)
	--if ply.y > 0 then
	--	cy = math.floor(ply.y / tile_h)
	--	ply.u = tostring(map[cy + 1][ply.x])
	--end

	if ply.y > 0 then
		if ply.y == 0 then
			cellx = 1
		end 
		if ply.y == 8 then
			cellx = 2
		end 
		if ply.y == 24 then
			cellx = 3
		end
		cy = math.floor(ply.y / tile_h)
		ply.d = tostring(map[cellx + 1][cx + 1])

		if ply.d == "1" then
			--love.event.push("q")
			if ply.inv then
				print("ignoring, invincible")
			else
				print("hit")
			end
		else
			print("not hit")
		end
	end
end

function move()
	ply.x = ply.x + 8
end

function love.draw()
	draw_map()
	love.graphics.draw(ply.img, ply.x, ply.y)
	love.graphics.print(ply.score, 0, 100)
	love.graphics.print(cx .. cy, 0, 120)
	love.graphics.print(tostring(ply.u .. ply.d), 0, 140)
end